#! /bin/sh
#
# 	Part of kde-service-menu-pdf Version 0.5
# 	Copyright (C) 2011 Giuseppe Benigno <giuseppe.benigno(at)gmail.com>
#
# 	This program is free software: you can redistribute it and/or modify
# 	it under the terms of the GNU General Public License as published by
# 	the Free Software Foundation, either version 3 of the License, or
# 	(at your option) any later version.
#
# 	This program is distributed in the hope that it will be useful,
# 	but WITHOUT ANY WARRANTY; without even the implied warranty of
# 	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# 	GNU General Public License for more details.
#
# 	You should have received a copy of the GNU General Public License
# 	along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

lang=`echo "${1}" | sed -e "s/@//g"`
shift
action="${1}"
shift
workDir="${1%/*}"; if [ ! -d "${workDir}" ]; then workDir="./"; fi
baseFileName=`echo "${@}" | sed -e "s/ \//\n\//g" | sed -e "s/ /\ /g" | sed -e "s/.*\// /" | sed -e "s/[.]pdf$//" | tr "\n" "," | sed -e "s/^ \(.*\),[[:blank:]]*$/\1/"`

#### languages strings messages #################
# Syntax for strings name is: msg_[$action]_$window_[$section]
# For languages as sr@Latn use srLatn

load_language_en () {
	msg_saveFile_title="Save file ..."

	msg_join_oneFileOnly="Can't join one file only. Please select not less than two files."
	msg_join_saveFile_name="join of (${baseFileName}).pdf"
	msg_join_finish_title="Joined documents \"${baseFileName}\""
	msg_join_finish="Done."

	msg_add_openFile="Open document to add to \"${baseFileName}\""
	msg_add_saveFile_name="${baseFileName}_add.pdf"
	msg_add_finish_title="Added a document to \"${baseFileName}\""
	msg_add_finish="Done."

	msg_extract_inputPagesRange_title="Extract range"
	msg_extract_inputPagesRange="Notes: The keyword \"end\" may be used to reference the final page of a document instead of a page number. Reference a single page by omitting the ending page number. Please input pages range of \"${baseFileName}\" to extract:"
	msg_extract_saveFile_name="${baseFileName} (extracted pages).pdf"
	msg_extract_finish_title="Extracted pages from document \"${baseFileName}\""
	msg_extract_finish="Done."

	msg_extract_even_saveFile_name="${baseFileName} (even pages).pdf"
	msg_extract_even_finish_title="Extract all even pages from document \"${baseFileName}\""

	msg_extract_odd_saveFile_name="${baseFileName} (odd pages).pdf"
	msg_extract_odd_finish_title="Extract all odd pages from document \"${baseFileName}\""

	msg_burst_selectDir="Select destination directory"
	msg_burst_finish_title="Burst the document \"${baseFileName}\""
	msg_burst_finish="Done."

	msg_remove_inputPagesRange_title="Remove range"
	msg_remove_inputPagesRange="Notes: The keyword \"end\" may be used to reference the final page of a document instead of a page number. Reference a single page by omitting the ending page number. Please input pages range of \"${baseFileName}\" to remove:"
	msg_remove_removeAllPagesError="Can't remove all pages from document!"
	if [ -z "${range1}" ]; then msg_remove_saveFile_name="${baseFileName} (pages ${range2}).pdf"
		elif [ -z "${range2}" ]; then msg_remove_saveFile_name="${baseFileName} (pages ${range1}).pdf"
			elif [ "${range1}" != "${range2}" ]; then msg_remove_saveFile_name="${baseFileName} (pages ${range1}, ${range2}).pdf"
	fi
	msg_remove_finish_title="Removing pages from document \"${baseFileName}\""
	msg_remove_finish="Done."

	msg_rotateLeft_saveFile_name="${baseFileName} (left rotated).pdf"
	msg_rotateLeft_finish_title="Left rotation of document \"${baseFileName}\""
	msg_rotateLeft_finish="Done."

	msg_rotateRight_saveFile_name="${baseFileName} (right rotated).pdf"
	msg_rotateRight_finish_title="Right rotation of document \"${baseFileName}\""
	msg_rotateRight_finish="Done."

	msg_rotateOverturn_saveFile_name="${baseFileName} (overturned).pdf"
	msg_rotateOverturn_finish_title="Overturn document \"${baseFileName}\""
	msg_rotateOverturn_finish="Done."

	msg_rotateOriginal_saveFile_name="${baseFileName} (restored).pdf"
	msg_rotateOriginal_finish_title="Restored original orientation of document \"${baseFileName}\""
	msg_rotateOriginal_finish="Done."

	msg_repair_saveFile_name="${baseFileName} (repaired).pdf"
	msg_repair_finish_title="Repair the document \"${baseFileName}\""
	msg_repair_finish="Done."

	msg_watermark_openFile_title="Open document for to watermark \"${baseFileName}\""
	msg_watermark_saveFile_name="${baseFileName} (watermarked).pdf"
	msg_watermark_finish_title="Watermark pages of document \"${baseFileName}\""
	msg_watermark_finish="Done."

	msg_stamp_openFile_title="Open document for to stamp \"${baseFileName}\""
	msg_stamp_saveFile_name="${baseFileName} (stamped).pdf"
	msg_stamp_finish_title="Stamp pages of document \"${baseFileName}\""
	msg_stamp_finish="Done."

	msg_lock_saveFile_name="${baseFileName} (locked).pdf"
	msg_lock_permissions_title="Select permissions"
	msg_lock_permissions_text="Select permissions for document \"${baseFileName}\""
	msg_lock_permissions_printing_top="Top Quality Printing"
	msg_lock_permissions_printing_degradedPrinting="Lower Quality Printing"
	msg_lock_permissions_printing_modifyContents="Modify"
	msg_lock_permissions_printing_CopyContents="Copy contents"
	msg_lock_permissions_printing_ModifyAnnotations="Modify annotations"
	msg_lock_insertPasswd_title="Insert password"
	msg_lock_insertPassword_own="Master password is needed to set permissions. Please define master password for \"${baseFileName}\":"
	msg_lock_insertPassword_usr="Set user password if you want to allow only trusted people to read this file. The master password and the user password must be different. If you don't want this feature, leave text field empty. User password of document \"${baseFileName}\":"
	msg_lock_finish_title="Lock the document \"${baseFileName}\""
	msg_lock_finish="Done."

	msg_unlock_insertPasswd_title="Insert password"
	msg_unlock_insertPassword_own="Please insert main password of \"${baseFileName}\":"
	msg_unlock_saveFile_name="${baseFileName} (unlocked).pdf"
	msg_unlock_finish_title="Unlock the document \"${baseFileName}\""
	msg_unlock_finish="Done."

	msg_attach_openFile_title="Open file for attach to \"${baseFileName}\""
	msg_attach_saveFile_name="${baseFileName} (with attachment).pdf"
	msg_attach_finish_title="Attach arbitrary file to document \"${baseFileName}\""
	msg_attach_finish="Done."

	msg_unattach_selectDir="Select extraction directory"
	msg_unattach_finish_title="Copy all attached files of document \"${baseFileName}\""
	msg_unattach_finish="Done."

	msg_uncompress_saveFile_name="${baseFileName} (uncompressed).pdf"
	msg_uncompress_finish_title="Uncompress the document \"${baseFileName}\""
	msg_uncompress_finish="Done."

	msg_compress_saveFile_name="${baseFileName} (compressed).pdf"
	msg_compress_finish_title="Compress the document \"${baseFileName}\""
	msg_compress_finish="Done."

	msg_info_title="Document information"
}

load_language_it () {
	msg_saveFile_title="Salva file ..."

	msg_join_oneFileOnly="Non é possibile unire solo un file. Per favore, selezionane almeno due."
	msg_join_saveFile_name="unione di (${baseFileName}).pdf"
	msg_join_finish_title="Unione dei documenti \"${baseFileName}\""
	msg_join_finish="Finita."

	msg_add_openFile="Scegli il documento da aggiungere a \"${baseFileName}\""
	msg_add_saveFile_name="${baseFileName}_add.pdf"
	msg_add_finish_title="Aggiunta di un documento a \"${baseFileName}\""
	msg_add_finish="Conclusa."

	msg_extract_inputPagesRange_title="Range di estrazione"
	msg_extract_inputPagesRange="Note: La parola chiave \"end\" puó essere usata come riferimento alla pagina finale del documento al posto di un numero di pagina. É possibile riferirsi ad una singola pagina omettendo il numero di pagina finale. Per favore inserisci il range di pagine di \"${baseFileName}\" da estrarre:"
	msg_extract_saveFile_name="${baseFileName} (pagine estratte).pdf"
	msg_extract_finish_title="Estrazione delle pagine dal documento \"${baseFileName}\""
	msg_extract_finish="Finita."

	msg_extract_even_saveFile_name="${baseFileName} (pagine pari).pdf"
	msg_extract_even_finish_title="Estrazione di tutte le pagine pari dal documento \"${baseFileName}\""

	msg_extract_odd_saveFile_name="${baseFileName} (pagine dispari).pdf"
	msg_extract_odd_finish_title="Estrazione di tutte le pagine dispari dal documento \"${baseFileName}\""

	msg_burst_selectDir="Seleziona la cartella di destinazione"
	msg_burst_finish_title="Divisione completa del documento \"${baseFileName}\""
	msg_burst_finish="Completata."

	msg_remove_inputPagesRange_title="Range di rimozione"
	msg_remove_inputPagesRange="Note: La parola chiave \"end\" puó essere usata come riferimento alla pagina finale del documento al posto di un numero di pagina. É possibile riferirsi ad una singola pagina omettendo il numero di pagina finale. Per favore inserisci il range di pagine di \"${baseFileName}\" da rimuovere:"
	msg_remove_removeAllPagesError="Non è possibile rimuovoere tutte le pagine dal documento!"
	if [ -z "${range1}" ]; then msg_remove_saveFile_name="${baseFileName} (pagine ${range2}).pdf"
		elif [ -z "${range2}" ]; then msg_remove_saveFile_name="${baseFileName} (pagine ${range1}).pdf"
			elif [ "${range1}" != "${range2}" ]; then msg_remove_saveFile_name="${baseFileName} (pagine ${range1}, ${range2}).pdf"
	fi
	msg_remove_finish_title="Rimozione delle pagine dal documento \"${baseFileName}\""
	msg_remove_finish="Finita."

	msg_rotateLeft_saveFile_name="${baseFileName} (ruotato a sinistra).pdf"
	msg_rotateLeft_finish_title="Rotazione a sinistra del documento \"${baseFileName}\""
	msg_rotateLeft_finish="Eseguita."

	msg_rotateRight_saveFile_name="${baseFileName} (ruotato a destra).pdf"
	msg_rotateRight_finish_title="Rotazione a destra del documento \"${baseFileName}\""
	msg_rotateRight_finish="Eseguita."

	msg_rotateOverturn_saveFile_name="${baseFileName} (capovolto).pdf"
	msg_rotateOverturn_finish_title="Capovolgimento del documento \"${baseFileName}\""
	msg_rotateOverturn_finish="Concluso."

	msg_rotateOriginal_saveFile_name="${baseFileName} (ripristinato).pdf"
	msg_rotateOriginal_finish_title="Ripristino dell'orientazione originale del documento \"${baseFileName}\""
	msg_rotateOriginal_finish="Conclusa."

	msg_repair_saveFile_name="${baseFileName} (riparato).pdf"
	msg_repair_finish_title="Riparazione del documento \"${baseFileName}\""
	msg_repair_finish="Effettuata."

	msg_watermark_openFile_title="Scegli il documento da usare come filigrana per \"${baseFileName}\""
	msg_watermark_saveFile_name="${baseFileName} (con filigrana).pdf"
	msg_watermark_finish_title="Filigranatura delle pagine del documento \"${baseFileName}\""
	msg_watermark_finish="Completata."

	msg_stamp_openFile_title="Scegli il documento da usare come copertura di \"${baseFileName}\""
	msg_stamp_saveFile_name="${baseFileName} (coperto).pdf"
	msg_stamp_finish_title="Copertura delle pagine del documento \"${baseFileName}\""
	msg_stamp_finish="Finita."

	msg_lock_saveFile_name="${baseFileName} (protetto).pdf"
	msg_lock_permissions_title="Seleziona permessi"
	msg_lock_permissions_text="Seleziona permessi per il documento \"${baseFileName}\""
	msg_lock_permissions_printing_top="Stampa alla massima qualitá"
	msg_lock_permissions_printing_degradedPrinting="Stampa a bassa qualitá"
	msg_lock_permissions_printing_modifyContents="Modifica del contenuto"
	msg_lock_permissions_printing_CopyContents="Copia contenuto"
	msg_lock_permissions_printing_ModifyAnnotations="Modifica annotazioni"
	msg_lock_insertPasswd_title="Inserisci password"
	msg_lock_insertPassword_own="La password principale é necessaria per impostare i permessi. Per favore inserisci la password principale di \"${baseFileName}\":"
	msg_lock_insertPassword_usr="La password utente è utile per consentire la lettura solo alle persone fidate. La password principale e quella utente devono essere diverse. Se non vuoi usufruire di questa funzionalità lascia il seguente campo vuoto. Password utente del documento \"${baseFileName}\":"

	msg_lock_finish_title="Protezione del documento \"${baseFileName}\""
	msg_lock_finish="Eseguita."

	msg_unlock_insertPasswd_title="Inserisci password"
	msg_unlock_insertPassword_own="Per favore inserisci la passoerd principale di \"${baseFileName}\":"
	msg_unlock_saveFile_name="${baseFileName} (sprotetto).pdf"
	msg_unlock_finish_title="Sprotezione del documento \"${baseFileName}\""
	msg_unlock_finish="Eseguita."

	msg_attach_openFile_title="Scegli il file da allegare a \"${baseFileName}\""
	msg_attach_saveFile_name="${baseFileName} (con allegati).pdf"
	msg_attach_finish_title="Allegamento di un file al documento \"${baseFileName}\""
	msg_attach_finish="Concluso."

	msg_unattach_selectDir="Seleziona la cartella di estrazione"
	msg_unattach_finish_title="Copia di tutti i file allegati al documento \"${baseFileName}\""
	msg_unattach_finish="Conclusa."

	msg_uncompress_saveFile_name="${baseFileName} (scompattato).pdf"
	msg_uncompress_finish_title="Decompressione del documento \"${baseFileName}\""
	msg_uncompress_finish="Finita."

	msg_compress_saveFile_name="${baseFileName} (compressed).pdf"
	msg_compress_finish_title="Compressione del documento \"${baseFileName}\""
	msg_compress_finish="Finita."

	msg_info_title="Informazioni sul documento"
}

load_language_de () {
	msg_saveFile_title="Datei speichern ..."

	msg_join_oneFileOnly="Eine Datei kann nicht verbunden werden. Bitte mindestens zwei Dateien auswählen."
	msg_join_saveFile_name="Verbindung von (${baseFileName}).pdf"
	msg_join_finish_title="Verbindung der Dokumente \"${baseFileName}\""
	msg_join_finish="Fertig."

	msg_add_openFile="Dokument öffnen, das hinzugefügt werden soll \"${baseFileName}\""
	msg_add_saveFile_name="${baseFileName}_hinzugefügt.pdf"
	msg_add_finish_title="Dokument zu  \"${baseFileName}\" hinzugefügt."
	msg_add_finish="Fertig."

	msg_extract_inputPagesRange_title="Seiten für den Auszug"
	msg_extract_inputPagesRange="Beachte: Das Schlüsselwort \"end\" kann für die letzte Seite benutzt werden, anstatt deren Seitenzahl anzugeben. Um nur eine einzelne Seite heraus zu ziehen einfach die Endnummer weg lassen. Bitte Bereich eingeben, um Seiten aus der Datei \"${baseFileName}\" heraus zu ziehen:"
	msg_extract_saveFile_name="${baseFileName} (Auszug).pdf"
	msg_extract_finish_title="Seiten aus Dokument \"${baseFileName}\" herausgezogen"
	msg_extract_finish="Fertig."

	msg_extract_even_saveFile_name="${baseFileName} (gerade Seiten).pdf"
	msg_extract_even_finish_title="Alle geraden Seiten von \"${baseFileName}\" herausziehen"

	msg_extract_odd_saveFile_name="${baseFileName} (ungerade Seiten).pdf"
	msg_extract_odd_finish_title="Alle ungeraden Seiten von \"${baseFileName}\" herausziehen"

	msg_burst_selectDir="Zielverzeichnis auswählen"
	msg_burst_finish_title="Dokument \"${baseFileName}\" sprengen"
	msg_burst_finish="Done."

	msg_remove_inputPagesRange_title="Bereich, der entfernt werden soll"
	msg_remove_inputPagesRange="Beachte: Das Schlüsselwort \"end\" kann für die letzte Seite benutzt werden, anstatt deren Seitenzahl anzugeben. Um nur eine einzelne Seite heraus zu ziehen einfach die Endnummer weg lassen. Bitte Bereich eingeben, um Seiten aus der Datei \"${baseFileName}\" zu entfernen:"
	msg_remove_removeAllPagesError="Kann nicht entfernen Sie alle Seiten aus dem Dokument!"
	if [ -z "${range1}" ]; then msg_remove_saveFile_name="${baseFileName} (Seiten ${range2}).pdf"
		elif [ -z "${range2}" ]; then msg_remove_saveFile_name="${baseFileName} (Seiten ${range1}).pdf"
			elif [ "${range1}" != "${range2}" ]; then msg_remove_saveFile_name="${baseFileName} (Seiten ${range1}, ${range2}).pdf"
	fi
	msg_remove_finish_title="Seiten entfernen in Datei \"${baseFileName}\""
	msg_remove_finish="Fertig."

	msg_rotateLeft_saveFile_name="${baseFileName} (links gedreht).pdf"
	msg_rotateLeft_finish_title="Links ausrichten von Dokument \"${baseFileName}\""
	msg_rotateLeft_finish="Fertig."

	msg_rotateRight_saveFile_name="${baseFileName} (rechts gedreht).pdf"
	msg_rotateRight_finish_title="Rechts ausrichten von Dokument \"${baseFileName}\""
	msg_rotateRight_finish="Fertig."

	msg_rotateOverturn_saveFile_name="${baseFileName} (umgedreht).pdf"
	msg_rotateOverturn_finish_title="Dokument \"${baseFileName}\" umdrehen"
	msg_rotateOverturn_finish="Fertig."

	msg_rotateOriginal_saveFile_name="${baseFileName} (wiederhergestellt).pdf"
	msg_rotateOriginal_finish_title="Ursprüngliche Ausrichtung von \"${baseFileName}\" wiederherstellen"
	msg_rotateOriginal_finish="Fertig."

	msg_repair_saveFile_name="${baseFileName} (repariert).pdf"
	msg_repair_finish_title="Reparieren von \"${baseFileName}\""
	msg_repair_finish="Fertig."

	msg_watermark_openFile_title="Datei für das Wasserzeichen öffnen \"${baseFileName}\""
	msg_watermark_saveFile_name="${baseFileName} (Wasserzeichen).pdf"
	msg_watermark_finish_title="Wasserzeichen hinzufügen für \"${baseFileName}\""
	msg_watermark_finish="Fertig."

	msg_stamp_openFile_title="Datei zum Stempeln öffnen \"${baseFileName}\""
	msg_stamp_saveFile_name="${baseFileName} (gestempelt).pdf"
	msg_stamp_finish_title="Stempeln von \"${baseFileName}\""
	msg_stamp_finish="Fertig."

	msg_lock_saveFile_name="${baseFileName} (gesperrt).pdf"
	msg_lock_permissions_title="Berechtigungen auswählen"
	msg_lock_permissions_text="Berechtigungen für Dokument \"${baseFileName}\" auswählen"
	msg_lock_permissions_printing_top="Drucken in hoher Qualität"
	msg_lock_permissions_printing_degradedPrinting="Drucken in niedriger Qualität"
	msg_lock_permissions_printing_modifyContents="Ändern"
	msg_lock_permissions_printing_CopyContents="Inhalte kopieren"
	msg_lock_permissions_printing_ModifyAnnotations="Anmerkungen ändern"
	msg_lock_insertPasswd_title="Passwort eingeben"
	msg_lock_insertPassword_own="Das Masterpasswort wird benötigt um Berechtigungen zu setzen. Bitte Masterpasswort für \"${baseFileName}\" festlegen:"
	msg_lock_insertPassword_usr="Setzen Sie ein Benutzerpasswort, um das Dokument vor unerlaubtem Lesezugriff zu schützen. Das Masterpasswort und das Benutzerpasswort müssen unterschiedlich sein. Wenn Sie uneingeschränkten Lesezugriff möchten, lassen Sie dieses Passwort leer. Benutzerpasswort für Dokument \"${baseFileName}\" festlegen:"
	msg_lock_finish_title="Sperren von \"${baseFileName}\""
	msg_lock_finish="Fertig."

	msg_unlock_insertPasswd_title="Passwort eingeben"
	msg_unlock_insertPassword_own="Bitte Masterpasswort für \"${baseFileName}\" eingeben:"
	msg_unlock_saveFile_name="${baseFileName} (entsperrt).pdf"
	msg_unlock_finish_title="Entsperren von \"${baseFileName}\""
	msg_unlock_finish="Fertig."

	msg_attach_openFile_title="Datei zum Anhängen öffnen \"${baseFileName}\""
	msg_attach_saveFile_name="${baseFileName} (mit Anhang).pdf"
	msg_attach_finish_title="Datei an Dokument \"${baseFileName}\" anhängen"
	msg_attach_finish="Fertig."

	msg_unattach_selectDir="Ordner zum Speichern..."
	msg_unattach_finish_title="Kopieren der angehängten Dateien aus \"${baseFileName}\""
	msg_unattach_finish="Fertig."

	msg_uncompress_saveFile_name="${baseFileName} (unkomprimiert).pdf"
	msg_uncompress_finish_title="Dekomprimierung von \"${baseFileName}\""
	msg_uncompress_finish="Fertig."

	msg_compress_saveFile_name="${baseFileName} (komprimiert).pdf"
	msg_compress_finish_title="Komprimierung von \"${baseFileName}\""
	msg_compress_finish="Fertig."

	msg_info_title="Dokument-Informationen"
}

################################################

join () {
	if [ ${#} -lt 2 ]; then
		kdialog -sorry "${msg_join_oneFileOnly}"
		exit
	fi

	outputFileName="`kdialog --title "${msg_saveFile_title}" --caption "${msg_saveFile_title}" --icon document-save --getsavefilename "${workDir}/${msg_join_saveFile_name}" application/pdf`" || exit
	pdftk "${@}" cat output "${outputFileName}" && \
	kdialog --title "${msg_join_finish_title}" --passivepopup "${msg_join_finish}" 5
}

add () {
	pdfToAdd="`kdialog --title "${msg_add_openFile}" --caption "${msg_add_openFile}" --icon document-open --getopenfilename "." application/pdf`" || exit
	outputFileName="`kdialog --title "${msg_saveFile_title}" --caption "${msg_saveFile_title}" --icon document-save --getsavefilename "${workDir}/${msg_add_saveFile_name}" application/pdf`" || exit
	pdftk "${@}" "${pdfToAdd}" output "${outputFileName}" && \
	kdialog --title "${msg_add_finish_title}" --passivepopup "${msg_add_finish}" 5
}

#---------------------------------------------------------------------------------------------------------------------------------------------------

extract () {
	range=`kdialog --title "${msg_extract_inputPagesRange_title}" --caption "${msg_extract_inputPagesRange_title}" --icon edit-copy --inputbox "${msg_extract_inputPagesRange}" "1-end"` || exit
	outputFileName="`kdialog --title "${msg_saveFile_title}" --caption "${msg_saveFile_title}" --icon document-save --getsavefilename "${workDir}/${msg_extract_saveFile_name}" application/pdf`" || exit
	pdftk "${@}" cat ${range} output "${outputFileName}" && \
	kdialog --title "${msg_extract_finish_title}" --passivepopup "${msg_extract_finish}" 5
}

extract_even () {
	outputFileName="`kdialog --title "${msg_saveFile_title}" --caption "${msg_saveFile_title}" --icon document-save --getsavefilename "${workDir}/${msg_extract_even_saveFile_name}" application/pdf`" || exit
	pdftk "${@}" cat 1-endeven output "${outputFileName}" && \
	kdialog --title "${msg_extract_even_finish_title}" --passivepopup "${msg_extract_finish}" 5
}

extract_odd () {
	outputFileName="`kdialog --title "${msg_saveFile_title}" --caption "${msg_saveFile_title}" --icon document-save --getsavefilename "${workDir}/${msg_extract_odd_saveFile_name}" application/pdf`" || exit
	pdftk "${@}" cat 1-endodd output "${outputFileName}" && \
	kdialog --title "${msg_extract_odd_finish_title}" --passivepopup "${msg_extract_finish}" 5
}

burst () {
	burstDir="`kdialog --title "${msg_burst_selectDir}" --caption "${msg_burst_selectDir}" --icon document-save-all --getexistingdirectory "."`" || exit
	cd "${burstDir}" && \
	pdftk "${@}" burst output "${burstDir}/${baseFileName}_%04d.pdf" && \
	rm "${burstDir}/doc_data.txt" && \
	kdialog --title "${msg_burst_finish_title}" --passivepopup "${msg_burst_finish}" 5
}

remove () {
	range=`kdialog --title "${msg_remove_inputPagesRange_title}" --caption "${msg_remove_inputPagesRange_title}" --icon edit-copy --inputbox "${msg_remove_inputPagesRange}" "2-end"` || exit
	# delete spaces
	range=$(echo "${range}" | sed 's/[[:blank:]]*//g')

	# take total number of pages
	totalPages=`pdftk "${@}" dump_data | grep "NumberOfPages" | cut -d" " -f 2-`

	## Check initial range limit and fix it
	# take string before last minus simbol
	first="${range%-*}"
	if [ "${first}" = "end" ]; then first="${totalPages}"
	else
		#Delete non-number digits
		first=$(echo "${first}" | sed "s/[^[0-9]]*//g")
		if [ -z "${first}" ]; then first=1
			else if [ "${first}" -eq 0 ]; then first=1
				else if [ "${first}" -gt "${totalPages}" ]; then first="${totalPages}"; fi
			fi
		fi
	fi

	## Check final range limit and fix it
	# take string after last minus simbol
	last="${range#*-}"
	if [ "${last}" = "end" ]; then last="${totalPages}"
	else
		#Delete non-number digits
		last=$(echo "${last}" | sed "s/[^[0-9]]*//g")
		if [ -z "${last}" ]; then last="${totalPages}"
			elif [ "${last}" -lt "${first}" ]; then last="${first}"
				elif [ "${last}" -gt "${totalPages}" ]; then last="${totalPages}"
		fi
	fi
	## Now, range limits are included in the page range of document
	## first >= 1 and last <= totalPages

	# Define range1
	if [ "${first}" -eq 1 ]; then range1=''
		elif [ "${first}" -eq 2 ]; then range1="1"
		else range1="1-$(($first-1))"
	fi

	# Define range2
	if [ "${last}" -eq "${totalPages}" ]; then range2=''
		elif [ "${last}" -eq "$((${totalPages}-1))" ]; then range2="${totalPages}"
		else range2="$(($last+1))-${totalPages}"
	fi

	# if you want remove all pages
	[ "x${range1}" = "x" -a "x${range2}" = "x" ] && kdialog --title "${msg_remove_inputPagesRange_title}" --caption "${msg_remove_inputPagesRange_title}" --icon edit-copy --sorry "${msg_remove_removeAllPagesError}" && exit 1

	"load_language_${lang}" || load_language_en
	outputFileName="`kdialog --title "${msg_saveFile_title}" --caption "${msg_saveFile_title}" --icon document-save --getsavefilename "${workDir}/${msg_remove_saveFile_name}" application/pdf`" || exit
	pdftk "${@}" cat ${range1} ${range2} output "${outputFileName}" && \
	kdialog --title "${msg_remove_finish_title}" --passivepopup "${msg_remove_finish}" 5
}

#---------------------------------------------------------------------------------------------------------------------------------------------------

left () {
	outputFileName="`kdialog --title "${msg_saveFile_title}" --caption "${msg_saveFile_title}" --icon document-save --getsavefilename "${workDir}/${msg_rotateLeft_saveFile_name}" application/pdf`" || exit
	pdftk "${@}" cat 1-endL output "${outputFileName}" && \
	kdialog --title "${msg_rotateLeft_finish_title}" --passivepopup "${msg_rotateLeft_finish}" 5
}

right () {
	outputFileName="`kdialog --title "${msg_saveFile_title}" --caption "${msg_saveFile_title}" --icon document-save --getsavefilename "${workDir}/${msg_rotateRight_saveFile_name}" application/pdf`" || exit
	pdftk "${@}" cat 1-endR output "${outputFileName}" && \
	kdialog --title "${msg_rotateRight_finish_title}" --passivepopup "${msg_rotateRight_finish}" 5
}

overturn () {
	outputFileName="`kdialog --title "${msg_saveFile_title}" --caption "${msg_saveFile_title}" --icon document-save --getsavefilename "${workDir}/${msg_rotateOverturn_saveFile_name}" application/pdf`" || exit
	pdftk "${@}" cat 1-endD output "${outputFileName}" && \
	kdialog --title "${msg_rotateOverturn_finish_title}" --passivepopup "${msg_rotateOverturn_finish}" 5
}

restore () {
	outputFileName="`kdialog --title "${msg_saveFile_title}" --caption "${msg_saveFile_title}" --icon document-save --getsavefilename "${workDir}/${msg_rotateOriginal_saveFile_name}" application/pdf`" || exit
	pdftk "${@}" cat 1-endN output "${outputFileName}" && \
	kdialog --title "${msg_rotateOriginal_finish_title}" --passivepopup "${msg_rotateOriginal_finish}" 5
}

#---------------------------------------------------------------------------------------------------------------------------------------------------

repair () {
	outputFileName="`kdialog --title "${msg_saveFile_title}" --caption "${msg_saveFile_title}" --icon document-save --getsavefilename "${workDir}/${msg_repair_saveFile_name}" application/pdf`" || exit
	pdftk "${@}" output "${outputFileName}" && \
	kdialog --title "${msg_repair_finish_title}" --passivepopup "${msg_repair_finish}" 5
}

watermark () {
	background="`kdialog --title "${msg_watermark_openFile_title}" --caption "${msg_watermark_openFile_title}" --icon document-open --getopenfilename "." application/pdf`" || exit
	outputFileName="`kdialog --title "${msg_saveFile_title}" --caption "${msg_saveFile_title}" --icon document-save --getsavefilename "${workDir}/${msg_watermark_saveFile_name}" application/pdf`" || exit
	pdftk "${@}" background "${background}" output "${outputFileName}" && \
	kdialog --title "${msg_watermark_finish_title}" --passivepopup "${msg_watermark_finish}" 5
}

stamp () {
	stamp="`kdialog --title "${msg_stamp_openFile_title}" --caption "${msg_stamp_openFile_title}" --icon document-open --getopenfilename "." application/pdf`" || exit
	outputFileName="`kdialog --title "${msg_saveFile_title}" --caption "${msg_saveFile_title}" --icon document-save --getsavefilename "${workDir}/${msg_stamp_saveFile_name}" application/pdf`" || exit
	pdftk "${@}" stamp "${stamp}" output "${outputFileName}" && \
	kdialog --title "${msg_stamp_finish_title}" --passivepopup "${msg_stamp_finish}" 5
}

#---------------------------------------------------------------------------------------------------------------------------------------------------

lock () {
	own_passwd="`kdialog --title "${msg_lock_insertPasswd_title}" --caption "${msg_lock_insertPasswd_title}" --password "${msg_lock_insertPassword_own}"`" || exit
	usr_passwd="`kdialog --title "${msg_lock_insertPasswd_title}" --caption "${msg_lock_insertPasswd_title}" --password "${msg_lock_insertPassword_usr}"`" || exit
	permissions=`kdialog --title "${msg_lock_permissions_title}" --caption "${msg_lock_permissions_title}" --icon configure --checklist "${msg_lock_permissions_text}" Printing "${msg_lock_permissions_printing_top}" off DegradedPrinting "${msg_lock_permissions_printing_degradedPrinting}" off ModifyContents "${msg_lock_permissions_printing_modifyContents}" off CopyContents "${msg_lock_permissions_printing_CopyContents}" off ModifyAnnotations "${msg_lock_permissions_printing_ModifyAnnotations}" off --separate-output` || exit
	outputFileName="`kdialog --title "${msg_saveFile_title}" --caption "${msg_saveFile_title}" --icon document-save --getsavefilename "${workDir}/${msg_lock_saveFile_name}" application/pdf`" || exit
	pdftk "${@}" output "${outputFileName}" allow ${permissions} owner_pw "${own_passwd}" user_pw "${usr_passwd}" && \
	kdialog --title "${msg_lock_finish_title}" --passivepopup "${msg_lock_finish}" 5
}

unlock () {
	passwd="`kdialog --title "${msg_unlock_insertPasswd_title}" --caption "${msg_unlock_insertPasswd_title}" --password "${msg_unlock_insertPassword_own}"`" || exit
	outputFileName="`kdialog --title "${msg_saveFile_title}" --caption "${msg_saveFile_title}" --icon document-save --getsavefilename "${workDir}/${msg_unlock_saveFile_name}" application/pdf`" || exit
	pdftk "${@}" input_pw "${passwd}" output "${outputFileName}" && \
	kdialog --title "${msg_unlock_finish_title}" --passivepopup "${msg_unlock_finish}" 5
}

#---------------------------------------------------------------------------------------------------------------------------------------------------

attach () {
	filesToAttach="`kdialog --title "${msg_attach_openFile_title}" --caption "${msg_attach_openFile_title}" --icon document-open --getopenfilename "."`" || exit
	outputFileName="`kdialog --title "${msg_saveFile_title}" --caption "${msg_saveFile_title}" --icon document-save --getsavefilename "${workDir}/${msg_attach_saveFile_name}" application/pdf`" || exit
	pdftk "${@}" attach_files "${filesToAttach}" output "${outputFileName}" && \
	kdialog --title "${msg_attach_finish_title}" --passivepopup "${msg_attach_finish}" 5
}

unattach () {
	outputDir="`kdialog --title "${msg_unattach_selectDir}" --caption "${msg_unattach_selectDir}" --icon folder --getexistingdirectory "${workDir}/"`" || exit
	pdftk "${@}" unpack_files output "${outputDir}" && \
	kdialog --title "${msg_unattach_finish_title}" --passivepopup "${msg_unattach_finish}" 5
}

#---------------------------------------------------------------------------------------------------------------------------------------------------

uncompress () {
	outputFileName="`kdialog --title "${msg_saveFile_title}" --caption "${msg_saveFile_title}" --icon document-save --getsavefilename "${workDir}/${msg_uncompress_saveFile_name}" application/pdf`" || exit
	pdftk "${@}" output "${outputFileName}" uncompress && \
	kdialog --title "${msg_uncompress_finish_title}" --passivepopup "${msg_uncompress_finish}" 5
}

compress () {
	outputFileName="`kdialog --title "${msg_saveFile_title}" --caption "${msg_saveFile_title}" --icon document-save --getsavefilename "${workDir}/${msg_compress_saveFile_name}" application/pdf`" || exit
	pdftk "${@}" output "${outputFileName}" compress && \
	kdialog --title "${msg_compress_finish_title}" --passivepopup "${msg_compress_finish}" 5
}

#---------------------------------------------------------------------------------------------------------------------------------------------------

info () {
	msg="`pdftk "${@}" dump_data && echo ' '`"
	kdialog --icon help-about --title "${msg_info_title}" --caption "${msg_info_title}" --msgbox "${msg}"
}

#### main

cd "${workDir}"
    "load_language_${lang}" || load_language_en
	"${action}" "${@}"
cd -
